;FWELD makes a Fillet Weld Symbol at 2 given points; user supplies weld size
;      and side, also all around symbol
; John Watson  08/28/90    (basic idea from BALLOON.LSP by Dale Seiler)
;
(defun c:fweld(/ allar wsize wside wlen arrw scle txth pt1 pt2 pt3 pt4 
                 pt5 pt6 pt7 xp1 xp2 angrad angdeg cmdekko hilite)
(setq cmdekko (getvar "cmdecho"))
(setq hilite (getvar "blipmode"))
(setvar "cmdecho" 0)
(setq arrw (* (getvar "dimasz") (getvar "dimscale")))
(setq scle (getvar "dimscale"))
(setq txth (* (getvar "dimtxt") (getvar "dimscale")))  
(setq pt1 (getpoint "\nEnter arrow end of Weld Symbol: "))
(setq pt2 (getpoint "\nEnter other end of Weld Symbol: "))
(setvar "blipmode" 0)
(initget  "O B T")
(setq wside (getkword "\nWeld on which side?: Other/Both/<This>"))
(setq wsize (getstring "\nWeld Fillet Size: "))
(if (> (strlen wsize) 3)(setq wsize (substr wsize 1 3)))
(setq wlen (getstring "\nLength-Pitch of Weld: "))
(initget "Y N")
(setq allar (getkword "\nWeld All Around?: Y/<N> "))
(setq angrad (angle pt1 pt2))
(setq angdeg (* angrad 57.29578))
(command "line" pt1 pt2)
(command)
(if (or (<= angdeg 90) (>= angdeg 270))
    (setq pt3 (polar pt2 0 (* scle 0.5)))
         (setq pt3  (polar pt2 pi (* scle 0.7))))
(if (or (<= angdeg 90) (>= angdeg 270))
    (setq pt5 (polar pt2 0 (* scle 1.2)))
         (setq pt5  (polar pt2 pi (* scle 1.2))))
(command "line" pt2 pt5)
(command)
(setq pt4 (polar pt1 angrad arrw)) 
(command "pline" pt1 "W" 0 (* arrw 0.33) pt4) 
(command)
(if (or (<= angdeg 90) (>= angdeg 270))
    (setq xp1 (polar pt2 0 (* scle 0.25)))
         (setq xp1 (polar pt2 pi (* scle 0.95))))
(if (or (<= angdeg 90) (>= angdeg 270))
    (setq xp2 (polar pt2 0 (* scle 0.95)))
         (setq xp2 (polar pt2 pi (* scle 0.25))))

(cond ((eq wside "O")
           (setq pt6 (polar xp1 1.5708 0.1))
           (command "line" pt3 "@0,0.2" "@0.282842712<315")
           (command)
           (command "TEXT" "m" pt6 0.1 0 wsize)
           (command)
           (cond ((/= wlen nil)
                     (setq pt7 (polar xp2 1.5708 0.1))
                     (command "TEXT" "m" pt7 0.1 0 wlen)
                     (command)
                  )
            )
      )
      ((eq wside "B")
           (setq pt6 (polar xp1 1.5708 0.1))
           (command "line" pt3 "@0,0.2" "@0.282842712<315")
           (command)
           (command "TEXT" "m" pt6 0.1 0 wsize)
           (command)
           (cond ((/= wlen nil)
                     (setq pt7 (polar xp2 1.5708 0.1))
                     (command "TEXT" "m" pt7 0.1 0 wlen)
                     (command)
                  )
            )
           (setq pt6 (polar xp1 4.7124 0.1))
           (command "line" pt3 "@0,-.2" "@.282842712<45")
           (command)
           (command "TEXT" "m" pt6 0.1 0 wsize)
           (command)
           (cond ((/= wlen nil)
                     (setq pt7 (polar xp2 4.7124 0.1))
                     (command "TEXT" "m" pt7 0.1 0 wlen)
                     (command)
                  )
            )
      )
      ((eq wside "T")
           (setq pt6 (polar xp1 4.7124 0.1))
           (command "line" pt3 "@0,-.2" "@.282842712<45")
           (command)
           (command "TEXT" "m" pt6 0.1 0 wsize)
           (command)
           (cond ((/= wlen nil)
                     (setq pt7 (polar xp2 4.7124 0.1))
                     (command "TEXT" "m" pt7 0.1 0 wlen)
                     (command)
                  )
            )
      )
      ((eq wside nil)
           (setq pt6 (polar xp1 4.7124 0.1))
           (command "line" pt3 "@0,-.2" "@.282842712<45")
           (command)
           (command "TEXT" "m" pt6 0.1 0 wsize)
           (command)
           (cond ((/= wlen nil)
                     (setq pt7 (polar xp2 4.7124 0.1))
                     (command "TEXT" "m" pt7 0.1 0 wlen)
                  )
            )
      )
)
(if (eq allar "Y") (command "circle" pt2 0.093))
(setvar "cmdecho" cmdekko)
(setvar "blipmode" hilite)
(prin1)
)
